part of yomp_yaml;

class Encoder {
	Writer _writer;
	
	Encoder(this._writer);

	void encode(Object obj) {
    	if (obj is Map) {
    		Map mp = obj;
			this._encodeMap(mp);
    	}		
	}
	void _encodeMap(Map mp,[int indent=0]) {
		String indentStr=this._indentionString(indent);
		String indentStrSub=this._indentionString(indent+1);
		mp.forEach((k,v) {
			String val;
			if (v is String)
				val = v;
			else if (v is Map) {
				this._writer.writeLine(indentStr+k+':');
				this._encodeMap(v,indent+1);
				return;
			} else
				val = v.toString();
			if (val.contains('\n')) {
				val = val.replaceAll('\n', '\n'+indentStrSub);
				val = '|\n'+indentStrSub+val;
			}
			this._writer.writeLine(indentStr+k+': '+val);
		});		
	}
	String _indentionString(int indent) {
		String str = "";
		for(int i=0;i<indent;i++)
			str += "  ";
		return str;
	}
}