part of yomp_yaml_tester;

void test_basic_map() {

	group('basic map -', () {
		test('string keys and values',() {
			Map mp = new Map();
			mp['name'] = 'YAML parser';
			mp['type'] = 'library';
			Map res = yyaml.decode(yyaml.encode(mp));
			expect(res,mp);
		});
		test('string values opposite order',() {
			Map mp = new Map();
			mp['type'] = 'library';
			mp['name'] = 'YAML parser';
			Map res = yyaml.decode(yyaml.encode(mp));
			expect(res,mp);
		});
		test('numeric values',() {
			Map mp = new Map();
			mp['type'] = 2;
			mp['name'] = 3.14;
			Map res = yyaml.decode(yyaml.encode(mp));
			expect(res,mp);
		});
		test('multiline value',() {
			Map mp = new Map();
			mp['type'] = 'library\nfor Dart\n';
			mp['name'] = 'YAML\nparser\nfor YOMP project\n';
			Map res = yyaml.decode(yyaml.encode(mp));
			expect(res,mp);
		});
		test('multiline value - indented',() {
			Map mp = new Map();
			mp['type'] = 'library\nfor Dart\n';
			mp['name'] = 'YAML\nparser\n  for YOMP project\n';
			Map res = yyaml.decode(yyaml.encode(mp));
			expect(res,mp);
		});
	});
}